HDU - 6709 Fishing Master(2019中国大学生程序设计竞赛(CCPC) - 网络选拔赛)

Fishing Master(贪心)

Heard that eom is a fishing MASTER, you want to acknowledge him as your mentor. As everybody knows, if you want to be a MASTER’s apprentice, you should pass the trial. So when you find fishing MASTER eom, the trial is as follow:

There are n fish in the pool. For the i - th fish, it takes at least ti minutes to stew(overcook is acceptable). To simplify this problem, the time spent catching a fish is k minutes. You can catch fish one at a time and because there is only one pot, only one fish can be stewed in the pot at a time. While you are catching a fish, you can not put a raw fish you have caught into the pot, that means if you begin to catch a fish, you can’t stop until after k minutes; when you are not catching fish, you can take a cooked fish (stewed for no less than ti) out of the pot or put a raw fish into the pot, these two operations take no time. Note that if the fish stewed in the pot is not stewed for enough time, you cannot take it out, but you can go to catch another fish or just wait for a while doing nothing until it is sufficiently stewed.

Now eom wants you to catch and stew all the fish as soon as possible (you definitely know that a fish can be eaten only after sufficiently stewed), so that he can have a satisfying meal. If you can complete that in the shortest possible time, eom will accept you as his apprentice and say “I am done! I am full!”. If you can’t, eom will not accept you and say “You are done! You are fool!”.

So what’s the shortest time to pass the trial if you arrange the time optimally?
Input
The first line of input consists of a single integer T(1≤T≤20), denoting the number of test cases.

For each test case, the first line contains two integers n(1≤n≤105),k(1≤k≤109), denoting the number of fish in the pool and the time needed to catch a fish.

the second line contains n integers, t1,t2,…,tn(1≤ti≤109) ,denoting the least time needed to cook the i - th fish.
Output
For each test case, print a single integer in one line, denoting the shortest time to pass the trial.
Sample Input
2
3 5
5 5 8
2 4
3 3
Sample Output
23
11

Hint
Case 1: Catch the 3rd fish (5 mins), put the 3rd fish in, catch the 1st fish (5 mins), wait (3 mins),

take the 3rd fish out, put the 1st fish in, catch the 2nd fish(5 mins),

take the 1st fish out, put the 2nd fish in, wait (5 mins), take the 2nd fish out.

Case 2: Catch the 1st fish (4 mins), put the 1st fish in, catch the 2nd fish (4 mins),

take the 1st fish out, put the 2nd fish in, wait (3 mins), take the 2nd fish out.

题意

有n个鱼,钓鱼的时间都是k,但是炖鱼的时间不一样,每个鱼都有一个炖鱼时间ti
钓鱼的时候啥也不能干,只能钓鱼(不能再钓鱼的期间去炖鱼或者换鱼)。但是炖鱼的时候可以去钓鱼,超过了该条鱼的炖鱼时间了也没关系,或者等着这条鱼煮好再去钓也没关系。问把所有鱼全钓上来炖了需要的最少时间。

思路

贪心,首先我们必花的时间是sum = (n*k)+(所有鱼炖的时间ti)
然后考虑怎么节省时间。
对于当前鱼:
如果ti>k, 则可以利用煮的时间白嫖一条鱼上来。
如果ti<k,则可以在把鱼放在锅里煮,然后去钓一条鱼,这样浪费的时间是k-ti。
具体看代码

代码

#include<cstdio>
#include<cstring>
#include<algorithm>
#define rep(i,a,b) for(int i=a;i<=b;i++)
#define ll long long
using namespace std;

bool cmp(ll c, ll d){
	return c>d;
}

int main(){
    int n, i, j, m;
    ll sum, cnt, cur,t;
    int T;
    ll a[100009], k; 
    scanf("%d",&T);
    while(T--){
        scanf("%d%lld",&n,&t);
        sum = (ll)n*t;
        cnt = 0;
        for(i = 1; i <= n; i++){
            scanf("%lld",&cur);
            k = cur/t;
            a[i] = cur-k*t;
            cnt += cur/t;
            sum += cur;
        }
        if(cnt>=n-1){
        	cnt = n-1;
        } 
        else if(cnt < n-1){
        	sort(a+1, a+1+n, cmp);
        	for( i = 1; i <= (n-1-cnt); i++){
        		sum -= a[i];
        	}
        }
        sum -= cnt*t;
        printf("%lld\n",sum);
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值